#15 via82cxxx_audio /dev/dsp broken

important
closed-invalid
misc PCI (4)
5
2001-04-14
2001-03-12
No

The 1.1.14b (and possibly earlier) version of the
via82cxxx_audio doesn't appear to interface with the
/dev/dsp device.

If you need help programming on this, please let me
know. I have very little experience writing this
stuff, but am willing to try. I use to be an Amiga
programmer and written several programs such as
SayMore, tiny_reboot, and a few others. I also wrote a
document on installing a 2MB Agnus chip on an Amiga
2000. Just to let you know I am a capable programmer.

Here is the debug output.

Thanks
Ken

via-audio-diag.c:v1.00 05/06/2000 Jeff Garzik
(jgarzik@mandrakesoft.com)
Index #1: Found a via 686a audio adapter at 0xac00.
AC97 RESET = 0x5800 (22528)
AC97 MASTER_VOL_STEREO = 0x0000 (0)
AC97 HEADPHONE_VOL = 0x8000 (32768)
AC97 MASTER_VOL_MONO = 0x0000 (0)
AC97 MASTER_TONE = 0x0000 (0)
AC97 PCBEEP_VOL = 0x0000 (0)
AC97 PHONE_VOL = 0x0000 (0)
AC97 MIC_VOL = 0x8000 (32768)
AC97 LINEIN_VOL = 0x0000 (0)
AC97 CD_VOL = 0x0000 (0)
AC97 VIDEO_VOL = 0x0000 (0)
AC97 AUX_VOL = 0x0000 (0)
AC97 PCMOUT_VOL = 0x0000 (0)
AC97 RECORD_SELECT = 0x0000 (0)
AC97 RECORD_GAIN = 0x0F0F (3855)
AC97 RECORD_GAIN_MIC = 0x0000 (0)
AC97 GENERAL_PURPOSE = 0x0000 (0)
AC97 3D_CONTROL = 0x0000 (0)
AC97 MODEM_RATE = 0x0000 (0)
AC97 POWER_CONTROL = 0x000F (15)
AC97 EXTENDED_ID = 0x0200 (512)
AC97 EXTENDED_STATUS = 0x0000 (0)
AC97 PCM_FRONT_DAC_RATE = 0x0000 (0)
AC97 PCM_SURR_DAC_RATE = 0x0000 (0)
AC97 PCM_LFE_DAC_RATE = 0x0000 (0)
AC97 PCM_LR_ADC_RATE = 0x0000 (0)
AC97 PCM_MIC_ADC_RATE = 0x0000 (0)
AC97 CENTER_LFE_MASTER = 0x0000 (0)
AC97 SURROUND_MASTER = 0x0000 (0)
AC97 RESERVED_3A = 0x0000 (0)
SGD Playback : 84 00 B7 02905E20 00000000
SGD Record : 00 00 00 00000000 00000000
SGD FM : 00 00 00 00000000 00000000
SGD Modem Playback : 00 00 00 00000000 00000000
SGD Modem Record : 00 00 00 00000000 00000000
SGD reg 0x80 = 0x00BA0000
SGD reg 0x84 = 0x00001100
SGD reg 0x88 = 0x00000000
SGD reg 0x8C = 0x00000000
PCI reg 0x10 = 0xD8000008
PCI reg 0x3C = 0x00
PCI reg 0x40 = 0x00
PCI reg 0x41 = 0x00
PCI reg 0x42 = 0x00
PCI reg 0x43 = 0x00
PCI reg 0x44 = 0x00
PCI reg 0x48 = 0x00

Discussion

  • Jeff Garzik

    Jeff Garzik - 2001-03-12
    • labels: --> misc PCI
    • assigned_to: nobody --> jgarzik
     
  • Jeff Garzik

    Jeff Garzik - 2001-03-25

    Logged In: YES
    user_id=17443

    Can you please provide more information about exactly what
    failures you are seeing?

    via82cxxx_audio driver in kernel 2.4.x exports a standard
    OSS /dev/dsp interface, which is used by many people
    successfully.

     
  • Kenton Groombridge

    Logged In: YES
    user_id=126870

    More information.

    When using realplay, I always get a message stating that the
    audio device is in use. All permissions are set correctly
    and this error occurs even if I am logged in as root.

    Heavy Gear demo fails with "SDL Parachute Deployed". Took
    me a while to find that it was the audio devices. I
    installed a ES1371 sound card and disabled the via82cxxx and
    everything works perfect.

    I did some experiments sending stuff directly to the
    /dev/dsp device and I got a message that it wasn't
    configured (or something like that). I deleted the audio
    devices and used MAKEDEV to recreate them. I verified the
    major/minor numbers and permissions.

    I do have OSS sound modules along with the via82cxxx
    compiled as modules and have them loaded. I am not sure
    what else I am missing, if anything. I have tried
    everything in my power to make this work right.

     
  • Jeff Garzik

    Jeff Garzik - 2001-03-25

    Logged In: YES
    user_id=17443

    Thanks, that helps. After loading the module, can you
    provide output from /usr/bin/dmesg?
    Also, what kernel version are you using?

     
  • Kenton Groombridge

    Logged In: YES
    user_id=126870

    I just downloaded and compiled the 2.4.3 kernel. Tested it
    out same problem. I checked and it has the latest
    via82cxxx_audio.c file.

    Here is a bunch of info. Not sure what else to add.

    Thanks,
    Ken

    dmesg

    Linux version 2.4.3 (root@buttercup.clds.net) (gcc version
    2.95.3 19991030 (prerelease)) #1 Fri Mar
    BIOS-provided physical RAM map:
    BIOS-e820: 0000000000000000 - 000000000009fc00 (usable)
    BIOS-e820: 000000000009fc00 - 00000000000a0000 (reserved)
    BIOS-e820: 00000000000f0000 - 0000000000100000 (reserved)
    BIOS-e820: 00000000ffff0000 - 0000000100000000 (reserved)
    BIOS-e820: 0000000000100000 - 000000000fff0000 (usable)
    BIOS-e820: 000000000fff3000 - 0000000010000000 (ACPI data)
    BIOS-e820: 000000000fff0000 - 000000000fff3000 (ACPI NVS)
    Scan SMP from c0000000 for 1024 bytes.
    Scan SMP from c009fc00 for 1024 bytes.
    Scan SMP from c00f0000 for 65536 bytes.
    Scan SMP from c009f800 for 4096 bytes.
    On node 0 totalpages: 65520
    zone(0): 4096 pages.
    zone(1): 61424 pages.
    zone(2): 0 pages.
    mapped APIC to ffffe000 (01444000)
    Kernel command line: BOOT_IMAGE=linux ro root=806
    Initializing CPU#0
    Detected 1022.278 MHz processor.
    Console: colour VGA+ 80x25
    Calibrating delay loop... 2038.16 BogoMIPS
    Memory: 255600k/262080k available (916k kernel code, 6092k
    reserved, 359k data, 220k init, 0k highm
    Dentry-cache hash table entries: 32768 (order: 6, 262144
    bytes)
    Buffer-cache hash table entries: 16384 (order: 4, 65536
    bytes)
    Page-cache hash table entries: 65536 (order: 6, 262144
    bytes)
    Inode-cache hash table entries: 16384 (order: 5, 131072
    bytes)
    CPU: Before vendor init, caps: 0183f9ff c1c3f9ff 00000000,
    vendor = 2
    CPU: L1 I Cache: 64K (64 bytes/line), D cache 64K (64
    bytes/line)
    CPU: L2 Cache: 512K (64 bytes/line)
    CPU: After vendor init, caps: 0183f9ff c1c3f9ff 00000000
    00000000
    CPU: After generic, caps: 0183f9ff c1c3f9ff 00000000
    00000000
    CPU: Common caps: 0183f9ff c1c3f9ff 00000000 00000000
    CPU: AMD Athlon(tm) Processor stepping 02
    Enabling fast FPU save and restore... done.
    Checking 'hlt' instruction... OK.
    POSIX conformance testing by UNIFIX
    mtrr: v1.37 (20001109) Richard Gooch (rgooch@atnf.csiro.au)
    mtrr: detected mtrr type: Intel
    PCI: PCI BIOS revision 2.10 entry at 0xfb170, last bus=1
    PCI: Using configuration type 1
    PCI: Probing PCI hardware
    PCI: Using IRQ router VIA [1106/0686] at 00:07.0
    Linux NET4.0 for Linux 2.4
    Based upon Swansea University Computer Society NET3.039
    apm: BIOS version 1.2 Flags 0x07 (Driver version 1.14)
    Starting kswapd v1.8
    parport0: PC-style at 0x378, irq 7 [PCSPP(,...)]
    parport_pc: Via 686A parallel port: io=0x378, irq=7, dma=3
    pty: 256 Unix98 ptys configured
    lp0: using parport0 (interrupt-driven).
    block: queued sectors max/low 169829kB/56609kB, 512 slots
    per queue
    Uniform Multi-Platform E-IDE driver Revision: 6.31
    ide: Assuming 33MHz system bus speed for PIO modes; override
    with idebus=xx
    VP_IDE: IDE controller on PCI bus 00 dev 39
    VP_IDE: chipset revision 6
    VP_IDE: not 100% native mode: will probe irqs later
    ide: Assuming 33MHz system bus speed for PIO modes; override
    with idebus=xx
    VP_IDE: VIA vt82c686a (rev 1b) IDE UDMA66 controller on
    pci00:07.1
    ide0: BM-DMA at 0xa000-0xa007, BIOS settings: hda:DMA,
    hdb:pio
    ide1: BM-DMA at 0xa008-0xa00f, BIOS settings: hdc:pio,
    hdd:pio
    hd1: C/H/S=20510/81/0 from BIOS ignored
    hda: LS-120 VER5 00 UHD Floppy, ATAPI FLOPPY drive
    hdb: IOMEGA ZIP 250 ATAPI, ATAPI FLOPPY drive
    ide0 at 0x1f0-0x1f7,0x3f6 on irq 14
    hda: 123264kB, 963/8/32 CHS, 533 kBps, 512 sector size, 720
    rpm
    hdb: set_drive_speed_status: status=0x51 { DriveReady
    SeekComplete Error }
    hdb: set_drive_speed_status: error=0x04
    ide0: Drive 1 didn't accept speed setting. Oh, well.
    hdb: 244736kB, 239/64/32 CHS, 4096 kBps, 512 sector size,
    2941 rpm
    Floppy drive(s): fd0 is 1.44M
    FDC 0 is a post-1991 82077
    Serial driver version 5.05 (2000-12-13) with MANY_PORTS
    SHARE_IRQ SERIAL_PCI enabled
    ttyS00 at 0x03f8 (irq = 4) is a 16550A
    ttyS01 at 0x02f8 (irq = 3) is a 16550A
    Linux Tulip driver version 0.9.14 (February 20, 2001)
    PCI: Found IRQ 11 for device 00:0c.0
    PCI: The same IRQ used for device 00:07.2
    PCI: The same IRQ used for device 00:07.3
    PCI: The same IRQ used for device 00:0d.0
    eth0: Lite-On 82c168 PNIC rev 32 at 0xbc00,
    00:A0:CC:57:67:24, IRQ 11.
    eth0: MII transceiver #1 config 3000 status 7829
    advertising 01e1.
    Linux agpgart interface v0.99 (c) Jeff Hartmann
    agpgart: Maximum main memory to use for agp memory: 203M
    agpgart: Detected Via Apollo Pro KX133 chipset
    agpgart: AGP aperture is 64M @ 0xd8000000
    SCSI subsystem driver Revision: 1.00
    PCI: Found IRQ 11 for device 00:0d.0
    PCI: The same IRQ used for device 00:07.2
    PCI: The same IRQ used for device 00:07.3
    PCI: The same IRQ used for device 00:0c.0
    sym53c8xx: at PCI bus 0, device 13, function 0
    sym53c8xx: setting PCI_COMMAND_PARITY...(fix-up)
    sym53c8xx: 53c895 detected with Tekram NVRAM
    sym53c895-0: rev 0x1 on pci bus 0 device 13 function 0 irq
    11
    sym53c895-0: Tekram format NVRAM, ID 7, Fast-40, Parity
    Checking
    scsi0 : sym53c8xx-1.7.3a-20010304
    Vendor: IBM Model: DCAS-34330W Rev: S65A
    Type: Direct-Access ANSI SCSI
    revision: 02
    Vendor: IBM Model: DDRS-39130D Rev: DC1B
    Type: Direct-Access ANSI SCSI
    revision: 02
    Vendor: CWS ORB2 Model: -SI U ID 4 Rev: D44
    Type: Direct-Access ANSI SCSI
    revision: 02
    Vendor: TOSHIBA Model: CD-ROM XM-6201TA Rev: 1030
    Type: CD-ROM ANSI SCSI
    revision: 02
    Detected scsi disk sda at scsi0, channel 0, id 0, lun 0
    Detected scsi disk sdb at scsi0, channel 0, id 1, lun 0
    Detected scsi removable disk sdc at scsi0, channel 0, id 4,
    lun 0
    sym53c895-0-<0,*>: FAST-20 WIDE SCSI 40.0 MB/s (50.0 ns,
    offset 15)
    SCSI device sda: 8467200 512-byte hdwr sectors (4335 MB)
    Partition check:
    sda: sda1 sda2 < sda5 sda6 sda7 sda8 >
    sym53c895-0-<1,*>: FAST-40 WIDE SCSI 80.0 MB/s (25.0 ns,
    offset 15)
    SCSI device sdb: 17850000 512-byte hdwr sectors (9139 MB)
    sdb: sdb1 sdb2 < sdb5 sdb6 >
    sym53c895-0-<4,*>: FAST-10 WIDE SCSI 20.0 MB/s (100.0 ns,
    offset 15)
    SCSI device sdc: 4307184 512-byte hdwr sectors (2205 MB)
    sdc: Write Protect is off
    sdc: sdc1 < sdc5 >
    Detected scsi CD-ROM sr0 at scsi0, channel 0, id 6, lun 0
    sym53c895-0-<6,*>: FAST-10 SCSI 10.0 MB/s (100.0 ns, offset
    16)
    sr0: scsi-1 drive
    Uniform CD-ROM driver Revision: 3.12
    NET4: Linux TCP/IP 1.0 for NET4.0
    IP Protocols: ICMP, UDP, TCP
    IP: routing cache hash table of 2048 buckets, 16Kbytes
    TCP: Hash tables configured (established 16384 bind 16384)
    NET4: Unix domain sockets 1.0/SMP for Linux NET4.0.
    VFS: Mounted root (ext2 filesystem) readonly.
    Freeing unused kernel memory: 220k freed
    Adding Swap: 257000k swap-space (priority -1)
    es1371: version v0.27 time 18:44:44 Mar 30 2001
    [drm] AGP 0.99 on VIA Apollo KX133 @ 0xd8000000 64MB
    [drm] Initialized radeon 1.0.1 20010308 on minor 0
    es1371: version v0.27 time 18:44:44 Mar 30 2001
    es1371: version v0.27 time 18:44:44 Mar 30 2001
    gameport0: NS558 ISA at 0x201 speed 532 kHz
    gameport1: NS558 ISA at 0x202 speed 532 kHz
    gameport2: NS558 ISA at 0x203 speed 532 kHz
    gameport3: NS558 ISA at 0x204 speed 532 kHz
    gameport4: NS558 ISA at 0x205 speed 532 kHz
    gameport5: NS558 ISA at 0x207 speed 532 kHz
    js0: Joystick device for input0
    input0: Gravis Xterminator DualControl on gameport5.0
    js1: Joystick device for input1
    input1: Gravis Xterminator DualControl on gameport4.0
    js2: Joystick device for input2
    input2: Gravis Xterminator DualControl on gameport3.0
    js3: Joystick device for input3
    input3: Gravis Xterminator DualControl on gameport2.0
    js4: Joystick device for input4
    input4: Gravis Xterminator DualControl on gameport1.0
    js5: Joystick device for input5
    input5: Gravis Xterminator DualControl on gameport0.0
    js0: Joystick device for input0
    input0: Gravis Xterminator DualControl on gameport5.0
    js1: Joystick device for input1
    input1: Gravis Xterminator DualControl on gameport4.0
    js2: Joystick device for input2
    input2: Gravis Xterminator DualControl on gameport3.0
    js3: Joystick device for input3
    input3: Gravis Xterminator DualControl on gameport2.0
    js4: Joystick device for input4
    input4: Gravis Xterminator DualControl on gameport1.0
    js5: Joystick device for input5
    input5: Gravis Xterminator DualControl on gameport0.0
    Via 686a audio driver 1.1.14b
    PCI: Found IRQ 9 for device 00:07.5
    via82cxxx: Codec rate locked at 48Khz
    ac97_codec: AC97 Audio codec, id: 0x414c:0x432f (Unknown)
    via82cxxx: board #1 at 0xAC00, IRQ 9

    cat /proc/modules

    via82cxxx_audio 17120 0
    ac97_codec 7728 0 [via82cxxx_audio]
    soundcore 3888 2 [via82cxxx_audio]
    grip 4224 0 (unused)
    joydev 5376 0
    input 3232 0 [grip joydev]
    ns558 2448 0 (unused)
    gameport 1728 0 [grip ns558]
    radeon 77648 1
    nls_iso8859-1 2864 1 (autoclean)
    nls_cp437 4384 1 (autoclean)

    ls -l /dev | grep audio

    crw-rw---- 1 root audio 14, 14 Feb 17 22:45
    admmidi0
    crw-rw---- 1 root audio 14, 30 Feb 17 22:45
    admmidi1
    crw-rw---- 1 root audio 14, 46 Feb 17 22:45
    admmidi2
    crw-rw---- 1 root audio 14, 62 Feb 17 22:45
    admmidi3
    crw-rw---- 1 root audio 14, 12 Feb 27 20:10
    adsp0
    crw-rw---- 1 root audio 14, 28 Feb 27 20:10
    adsp1
    crw-rw---- 1 root audio 14, 44 Feb 27 20:10
    adsp2
    crw-rw---- 1 root audio 14, 60 Feb 27 20:10
    adsp3
    crw-rw---- 1 root audio 116, 0 Feb 27 20:09
    aload0
    crw-rw---- 1 root audio 116, 32 Feb 27 20:09
    aload1
    crw-rw---- 1 root audio 116, 64 Feb 27 20:09
    aload2
    crw-rw---- 1 root audio 116, 96 Feb 27 20:09
    aload3
    crw-rw---- 1 root audio 116, 0 Feb 19 20:34
    aloadC0
    crw-rw---- 1 root audio 116, 32 Feb 19 20:34
    aloadC1
    crw-rw---- 1 root audio 116, 64 Feb 19 20:34
    aloadC2
    crw-rw---- 1 root audio 116, 96 Feb 19 20:34
    aloadC3
    crw-rw---- 1 root audio 116, 1 Feb 27 20:09
    aloadSEQ
    crw-rw---- 1 root audio 14, 13 Feb 27 20:09
    amidi0
    crw-rw---- 1 root audio 14, 29 Feb 27 20:09
    amidi1
    crw-rw---- 1 root audio 14, 45 Feb 27 20:09
    amidi2
    crw-rw---- 1 root audio 14, 61 Feb 27 20:09
    amidi3
    crw-rw---- 1 root audio 14, 11 Feb 19 20:34
    amixer0
    crw-rw---- 1 root audio 14, 27 Feb 19 20:34
    amixer1
    crw-rw---- 1 root audio 14, 43 Feb 19 20:34
    amixer2
    crw-rw---- 1 root audio 14, 59 Feb 19 20:34
    amixer3
    lrwxrwxrwx 1 root root 6 Feb 21 20:08
    audio -> audio0
    crw-rw---- 1 root audio 14, 4 Feb 21 20:10
    audio0
    crw-rw---- 1 root audio 14, 20 Feb 21 20:10
    audio1
    crw-rw---- 1 root audio 14, 36 Feb 21 20:10
    audio2
    crw-rw---- 1 root audio 14, 52 Feb 21 20:10
    audio3
    crw-rw---- 1 root audio 14, 7 Feb 21 20:10
    audioctl
    crw-rw---- 1 root audio 14, 10 Feb 27 20:10
    dmfm0
    crw-rw---- 1 root audio 14, 26 Feb 27 20:10
    dmfm1
    crw-rw---- 1 root audio 14, 42 Feb 27 20:10
    dmfm2
    crw-rw---- 1 root audio 14, 58 Feb 27 20:10
    dmfm3
    crw-rw---- 1 root audio 14, 9 Feb 27 20:10
    dmmidi0
    crw-rw---- 1 root audio 14, 25 Feb 27 20:10
    dmmidi1
    crw-rw---- 1 root audio 14, 41 Feb 27 20:10
    dmmidi2
    crw-rw---- 1 root audio 14, 57 Feb 27 20:10
    dmmidi3
    crw-rw---- 1 root audio 14, 3 Mar 11 19:19 dsp
    crw-rw---- 1 root audio 14, 3 Feb 19 20:34 dsp0
    crw-rw---- 1 root audio 14, 19 Mar 11 19:19 dsp1
    crw-rw---- 1 root audio 35, 0 Feb 21 20:10
    midi0
    crw-rw---- 1 root audio 14, 2 Feb 21 20:10
    midi00
    crw-rw---- 1 root audio 14, 18 Feb 21 20:10
    midi01
    crw-rw---- 1 root audio 14, 34 Feb 21 20:10
    midi02
    crw-rw---- 1 root audio 14, 50 Feb 21 20:10
    midi03
    crw-rw---- 1 root audio 35, 1 Feb 21 20:10
    midi1
    crw-rw---- 1 root audio 35, 2 Feb 21 20:10
    midi2
    crw-rw---- 1 root audio 35, 3 Feb 21 20:10
    midi3
    crw-rw---- 1 root audio 14, 0 Feb 23 21:38
    mixer
    crw-rw---- 1 root audio 14, 0 Feb 19 20:34
    mixer0
    crw-rw---- 1 root audio 14, 16 Feb 23 21:38
    mixer1
    crw-rw---- 1 root audio 14, 32 Feb 19 20:34
    mixer2
    crw-rw---- 1 root audio 14, 48 Feb 19 20:34
    mixer3
    crw-rw---- 1 root audio 14, 8 Feb 17 22:45
    music
    crw-rw---- 1 root audio 35, 64 Feb 17 22:45
    rmidi0
    crw-rw---- 1 root audio 35, 65 Feb 17 22:45
    rmidi1
    crw-rw---- 1 root audio 35, 66 Feb 17 22:45
    rmidi2
    crw-rw---- 1 root audio 35, 67 Feb 17 22:45
    rmidi3
    crw-rw---- 1 root audio 14, 1 Feb 21 20:10
    sequencer
    crw-rw---- 1 root audio 14, 8 Feb 21 20:10
    sequencer2
    crw-rw---- 1 root audio 35, 128 Feb 17 22:45
    smpte0
    crw-rw---- 1 root audio 35, 129 Feb 17 22:45
    smpte1
    crw-rw---- 1 root audio 35, 130 Feb 17 22:45
    smpte2
    crw-rw---- 1 root audio 35, 131 Feb 17 22:45
    smpte3
    crw-r--r-- 1 root audio 14, 6 Feb 27 20:01
    sndstat

     
  • Jeff Garzik

    Jeff Garzik - 2001-04-14

    Logged In: YES
    user_id=17443

    Ok, with this new output, I can see that your Via audio
    hardware appears to be functioning properly, and the audio
    driver is loaded properly.

    Note the message about you having a "locked rate codec."
    This means that your Via audio hardware can -only- play at
    48 Khz, and no other speed. To get esd working you need
    to use esd -r 48000 as it won't probe 48KHz by default.
    mpg123 can't handle 48Khz only audio so use xmms.

     
  • Jeff Garzik

    Jeff Garzik - 2001-04-14
    • status: open --> closed-invalid
     

Log in to post a comment.

Get latest updates about Open Source Projects, Conferences and News.

Sign up for the SourceForge newsletter:





No, thanks